#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/errno.h>
#include <memory.h>

#include "player.h"
#include "action.h"
#include "version.h"
#include "commands.h"

extern int numconns;

void action (int target)
{
register int retval, i, bytes_left;
char readbuf[BUFSIZE];
char donebuf [BUFSIZE];
char *ptr, *p, *buf;

	for (i=0; i < BUFSIZE; i++)
		donebuf[i] = '\0';

    retval = read(conns[target].sock, readbuf, sizeof(buf)-1);
    if (retval <= 0) {
		kill_conn (target, NULL);
		return;
	}


	while ((conns[target].bytes_read + retval) > conns[target].pbufsize) {
		conns[target].pbufsize = conns[target].pbufsize + PBUF_START_SIZE;
		conns[target].packetbuf = (char *) realloc(conns[target].packetbuf, 
									conns[target].pbufsize);
		if (!conns[target].packetbuf)
			crash ("REALLOC returned NULL in action.c\n");
	}

    memcpy(&(conns[target].packetbuf[conns[target].bytes_read]), readbuf, retval);
    conns[target].bytes_read = conns[target].bytes_read + retval;

	while (1) {
		ptr = (char *) memchr(conns[target].packetbuf, '\n', 
				conns[target].bytes_read);
		if (!ptr)
			return;

		i = 0;
		buf = donebuf;
		for (p = conns[target].packetbuf; p < ptr; p++) {
	    	if ((isprint(*p)) && (i < BUFSIZE-1)) {
				*buf++ = *p;
				i++;
			}
		}
		*buf = 0;

		bytes_left = conns[target].bytes_read - (ptr + 1 - 
					conns[target].packetbuf);
		memcpy(conns[target].packetbuf, ptr + 1, bytes_left);
		conns[target].bytes_read = bytes_left;

    	do_command(target, donebuf);
	}
}

void do_command (int target, char *donebuf)
{
char word1[12];
char rest[BUFSIZE];
register int i, j;
int pose_say = 0;
int poss = 0;

/* Clean out all of the buffers being used. */

    for (i=0; i < BUFSIZE; i++) {
        rest[i] = '\0';
	}
	for (i=0; i < 12; i++)
		word1[i] = '\0';

    for (i = 0; donebuf[i] != ' '; i++) {   /* place everything up to the */
        if (donebuf[i] == '\0')             /* first space into word1     */
			break;
		if (i == 12)
			return;
        word1[i] = donebuf[i];
        if ((donebuf[i] == '"') || (donebuf[i] == ':')) {
			if (donebuf[i+1] == ':') {
				poss = 1;
				break;
			}
            pose_say = 1;
            break;
        }
    }

    j = 0;
	if (poss) {
    	for (i = 2; donebuf[i] != '\0'; i++) {
        	rest[j] = donebuf[i];
        	j++;
    	}
	}
	else if (pose_say)
        word1[i+1] = '\0';
    else
        word1[i] = '\0';

	if (!poss)
    for (i = i+1; donebuf[i] != '\0'; i++) {  /* copy the rest of donebuf */
        rest[j] = donebuf[i];                 /* into the variable rest   */
        j++;
    }
	if (!strcmp (word1, "abort")) {
    	shutdown (conns[target].sock, 2);
    	close (conns[target].sock);
	    delete_conn (target);
	    return;
	}
    if ((!strncmp (word1, "conn", 4)) && (conns[target].state == S_CONNECTING)) {
		conn_player (target, rest);
		return;
	}
    if ((!strcmp (word1, "create")) && (conns[target].state == S_CONNECTING)) {
		create_player (target, rest);
		return;
	}
    if (!conns[target].state) {
        spewfile (target, "opening");
        return;
    }
	if (poss) {
		do_poss (target, rest);
		return;
	}
	for (i = 0; i < NUM_COMMANDS; i++)
		if (!strcmp(commands[i].name, word1)) {
			(commands[i].func)(target, (void *)rest);
			return;
		}
	if (strlen(word1) <= 0)
		return;
	else {
		write (conns[target].sock, "Buh?\n", 5);
		return;
	}
}
