#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

#include "version.h"
#include "player.h"

extern void boot (int from, char *person);
extern void clear (int target, void *foo);
extern void whisper (int from, char *string);
extern struct connection conns[ARRAYSIZE];
extern void spewfile (int target, char *fname);
extern void na (char *msg);
extern void wholist (int target, void *foo);
extern void finger (int target, void *foo);
extern void show_player (int target, void *foo);
extern void kill_conn (int target, void *foo);
extern int numconns;

void do_idle (int target, void *foo)
{
		write (conns[target].sock, "Now idling.\n", 12);
        conns[target].state = S_IDLE;
        return;
}

void do_unidle (int target, void *foo)
{
		write (conns[target].sock, "Now unidle.\n", 12);
        conns[target].state = S_UNIDLE;
        return;
}

void do_doing (int target, void *rest)
{
	if (strlen((char *)rest) > 52) {
		write (conns[target].sock, "Too long.\n", 10);
		return;
	}
	strncpy (conns[target].doing, (char *)rest, 52);
	conns[target].doing[strlen((char *)rest)] = '\0';
	write (conns[target].sock, "Set.\n", 5);
	return;
}

void do_quit (int target, void *foo)
{
	kill_conn (target, NULL);
	return;
}

void do_show (int target, void *foo)
{
	show_player (target, NULL);
	return;
}

void do_finger (int target, void *foo)
{
char rest[128];

	sprintf (rest, "%-15.15s %-40.40s\n", "Name","Address");
	write (conns[target].sock, rest, strlen(rest));
	sprintf (rest, "%-15.15s %-40.40s\n", "----","-------");
	write (conns[target].sock, rest, strlen(rest));
	finger (target, NULL);
	sprintf (rest, "%d current connections.\n", numconns);
	write (conns[target].sock, rest, strlen(rest));
	return;
}

void do_boot (int target, void *rest)
{
	boot (target, (char *) rest);
	return;
}

void do_whisper (int target, void *rest)
{
	whisper (target, (char *) rest);
	return;
}

void do_clear (int target, void *foo)
{
	clear(target, NULL);
	return;
}

void do_look (int target, void *foo)
{
char rest[500];

#ifdef MAIN_ROOM
register int i;
		spewfile (target, "room.desc");
		sprintf (rest, "You see: ");
		for (i = 0; i <= numconns-1; i++) {
			if ((numconns == 1) || (i == numconns-1))
				strcat (rest, conns[i].name);
			else {
				strcat (rest, conns[i].name);
				strcat (rest, ", ");
			}
		}
		strcat (rest, ".\n");
		write (conns[target].sock, rest, strlen(rest));
#else
		sprintf (rest, "The look command is not compiled in this version of the server.\n");
		write (conns[target].sock, rest, strlen(rest));
#endif
		return;
}

void do_who (int target, void *foo)
{
char rest[BUFSIZE];

	sprintf (rest, "%-15.15s %-6.6s %-52.52s\n", "Name","State","Doing");
	write (conns[target].sock, rest, strlen(rest));
	sprintf (rest, "%-15.15s %-6.6s %-52.52s\n", "----","-----","-----");
	write (conns[target].sock, rest, strlen(rest));
	wholist (target, NULL);
	sprintf (rest, "%d current connections.\n", numconns);
	write (conns[target].sock, rest, strlen(rest));
	return;
}

void do_version (int target, void *foo)
{
char rest[40];

	sprintf (rest, "GCS version %s\n", VERSION);
	write (conns[target].sock, rest, strlen(rest));
	return;
}

void do_help (int target, void *rest)
{
    if (strlen ((char *)rest) <= 0)
        spewfile (target, "help.main");
	else
		spewfile (target, (char *)rest);
	return;
}

void do_pose (int target, void *rest)
{
char playerbuf[BUFSIZE];

	sprintf (playerbuf, "%s %s\n", conns[target].name, (char *)rest);
	na (playerbuf);
	return;
}

void do_say (int target, void *rest)
{
char playerbuf[BUFSIZE];
char otherbuf[BUFSIZE];
register int curr;

	sprintf (playerbuf, "You say, \"%s\"\n", ((char *)rest));
	write (conns[target].sock, playerbuf, strlen(playerbuf));
	sprintf (otherbuf, "%s says, \"%s\"\n", conns[target].name,((char *)rest));
	for (curr=0; conns[curr].sock > -1; curr++)
		if ((conns[curr].sock != conns[target].sock) && (conns[curr].state == S_UNIDLE))
			write (conns[curr].sock, otherbuf, strlen(otherbuf));
	return;
}
