#include <stdio.h>
#include <stdlib.h>

struct command {
	char name[10];
	void (*func)(int, void *);
};

void do_boot (int target, void *rest);
void do_idle (int target, void *foo);
void do_unidle (int target, void *foo);
void do_doing (int target, void *rest);
void do_quit (int target, void *foo);
void do_show (int target, void *foo);
void do_finger (int target, void *foo);
void do_whisper (int target, void *foo);
void do_clear (int target, void *foo);
void do_look (int target, void *foo);
void do_who (int target, void *foo);
void do_version (int target, void *foo);
void do_help (int target, void *rest);
void do_pose (int target, void *rest);
void do_say (int target, void *rest);

struct command commands[] = { 
			{"who", do_who}, {"say", do_say},
			{":", do_pose}, {"\"", do_say},
			{"finger", do_finger}, {"WHO", do_who},
			{"idle", do_idle}, {"unidle", do_unidle},
			{"quit", do_quit}, {"QUIT", do_quit},
			{"doing", do_doing}, {"@who", do_who},
			{"@doing", do_doing}, {"show", do_show},
			{"clear", do_clear}, {"version", do_version},
			{"look", do_look}, {"whisper", do_whisper},
			{"whi", do_whisper}, {"help", do_help},
			{"l", do_look}, {";", do_pose},
			{"?", do_help}, {"boot", do_boot}
	};

#define NUM_COMMANDS (sizeof(commands) / sizeof(struct command))
