#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/stat.h>
#include "player.h"

extern struct connection conns[ARRAYSIZE];
extern int mastsock;
extern void serverlog(char *msg);

void crash (char *msg)
{
register int curr;

    for (curr=0; conns[curr].sock > -1; curr++) {
        write (conns[curr].sock, "Going down.\n", 12);
        shutdown (conns[curr].sock, 2);
        close (conns[curr].sock);
    }
    shutdown (mastsock, 2);
    close (mastsock);
    serverlog (msg);
    exit(1);
}

void sig_crash(int sig, int code)
{
 char buf[200];

   sprintf(buf, "SIG_CAUGHT: Signal %d caught.  Code %d\n", sig, code);
   crash(buf);
   exit(1);
}

/*
** Trap a slew of stupid signals.
*/
void set_signals(void)
{
#ifndef _LINUX
  signal(SIGEMT,    sig_crash);
  signal(SIGBUS,    sig_crash);
  signal(SIGSYS,    sig_crash);
#endif
  signal(SIGKILL,   sig_crash);
  signal(SIGPIPE,   SIG_IGN);
  signal(SIGTERM,   sig_crash);
  signal(SIGQUIT,   sig_crash);
  signal(SIGTRAP,   sig_crash);
  signal(SIGSEGV,   sig_crash);
  signal(SIGFPE,    sig_crash);
  signal(SIGTERM,   sig_crash);
  signal(SIGUSR2,   sig_crash);
  signal(SIGUSR1,   sig_crash);
  signal(SIGVTALRM, sig_crash);
  signal(SIGINT,    sig_crash);
}
