#include <stdio.h>
#include <stdlib.h>
#ifdef _HAVE_STRINGS_H
#include <strings.h>
#else
#include <string.h>
#endif
#include <sys/types.h>
#include <errno.h>

#include "player.h"
#include "gcs_op.h"

extern int errno;
extern struct connection conns[ARRAYSIZE];
extern char datestr[40];
extern int numconns;
extern void delete_conn(int victim);
extern int validpass (char *name, char *pword);
extern void reject_conn (int target);
void kill_conn (int target, void *foo);
void serverlog (char *msg);

void write_PID (void)
{
FILE *pidfp;
unsigned int pid = 0;
char buf[128];

	if ((pidfp = fopen("GCS.PID", "w")) == NULL) {
		printf ("Unable to write PID to file.\nServer not started.\n");
		exit (1);
	} else {
		pid = getpid();
		fprintf (pidfp, "%d\n", pid);
		fclose (pidfp);
		sprintf (buf, "Process ID is %d\n", pid);
		serverlog (buf);
	}
}

void boot (int from, char *person)
{
unsigned int i;
unsigned int exists = 0;
char buf[128];

    for (i = 0; conns[i].sock != -99; i++) {
        if (!strcasecmp (conns[i].name, person)) {
            exists = 1;
            break;
        }
    }
	if (!exists) {
		sprintf (buf, "That person is not connected.\n");
		write (conns[from].sock, buf, strlen(buf));
		return;
	}
	if (!strcmp (conns[from].name, MAINT_NAME)) {
		sprintf (buf, "You boot %s.\n", person);
		write (conns[from].sock, buf, strlen(buf));
	    write (conns[i].sock, "You have been booted.\n", 22);
		kill_conn (i, NULL);
		return;
	} else {
		sprintf (buf, "You are not the GCS maintainer.\n");
		write (conns[from].sock, buf, strlen(buf));
		return;
	}
}

void whisper (int from, char *string)
{
register int i, j;
int to;
char msg[BUFSIZE], outline[BUFSIZE];
char name[NAMESIZE];

	if (!memchr (string, ' ', 14)) {
		write (conns[from].sock, "Buh?\n", 5);
		return;
	}
	for (i = 0; string[i] != ' '; i++)
		name[i] = string[i];
	name[i] = '\0';
	i++;
	j = 0;
	for (i = i; string[i] != '\0'; i++) {
		msg[j] = string[i];
		j++;
	}
	msg[j] = '\0';
	to = -1;

	for (i = 0; conns[i].sock != -99; i++) {
		if (!strcasecmp (conns[i].name, name)) {
			to = i;
			break;
		}
	}
	if (to == -1) {
		sprintf (msg, "Player \"%s\" is not connected!\n", name);
		write (conns[from].sock, msg, strlen(msg));
	} else {
		sprintf (outline, "%s whispers, \"%s\" to you.\n",conns[from].name,msg);
		write (conns[to].sock, outline, strlen(outline));
		sprintf (outline, "Your whisper has been sent to %s\n", name);
		write (conns[from].sock, outline, strlen(outline));
		return;
	}
}

void show_player (int target, void *foo)
{
char buf[BUFSIZE];
	sprintf (buf, "Name: %s\n", conns[target].name);
	write (conns[target].sock, buf, strlen(buf));
	sprintf (buf, "Address: %s\n", conns[target].address);
	write (conns[target].sock, buf, strlen(buf));
	sprintf (buf, "Sock FD: %d\n", conns[target].sock);
	write (conns[target].sock, buf, strlen(buf));
	sprintf (buf, "Doing: %s\n", conns[target].doing);
	write (conns[target].sock, buf, strlen(buf));
	sprintf (buf, "Position In Array Of Players: %d\n", target);
	write (conns[target].sock, buf, strlen(buf));
	if (conns[target].state == S_UNIDLE)
		sprintf (buf, "State: Unidle/Active\n");
	else
		sprintf (buf, "State: Idle/InActive\n");
	write (conns[target].sock, buf, strlen(buf));

}

void clearsocks ()
{
register int i;
	for (i=0; i < ARRAYSIZE; i++)
		conns[i].sock = -99;
}

/*
** Sends 25 \n's
*/
void clear (int target, void *foo)
{
	write (conns[target].sock, "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n", 25);
}

/*
** nab  -- notify all but.  Spew a message to all player's sockets except
**         for one.
*/
void nab (int target, char *msg)
{
int i;
int retval;

	i = 0;
	while (conns[i].sock != -99) {
		if ((target == i) || (conns[i].state != S_UNIDLE)) {
			i++;
			continue;
		}
		retval = write (conns[i].sock, msg, strlen(msg));
		i++;
	}
}

/*
** na  -- notify all.  Spew a message to all player's sockets
*/
void na (char *msg)
{
register int curr;

    for (curr=0; curr <= numconns-1; curr++) {
        if (conns[curr].state != S_UNIDLE)
            continue;
        write (conns[curr].sock, msg, strlen(msg));
	}
}

void serverlog(char *msg)
{
FILE *serverfp;
char buf[80];

    if ((serverfp = fopen("server.log", "a")) == NULL) {
		sprintf (buf, "%d\n", errno);
		perror (buf);
        exit(1);
    }
    fputs (msg, serverfp);
    fclose (serverfp);
}

void spewfile (int target, char *fname)
{
FILE *fp;
register int i;
char buf[81];
char fnamebuf[12];

	for (i=0; i < 81; i++);
		buf[i] = '\0';
	if (strchr (fname, '/')) {
		sprintf (buf, "Illegal character in filename.\n");
        write (conns[target].sock, buf, strlen(buf));
        return;
	}
    strcpy (fnamebuf, "text/");
	if (fname[0] == '"')
		strcat (fnamebuf, "say");
	else if (fname[0] == ':')
		strcat (fnamebuf, "pose");
	else if ((fname[0] == ':') && (fname[1] == ':'))
		strcat (fnamebuf, "possessive");
	else
    	strcat (fnamebuf, fname);

    if ((fp = fopen (fnamebuf, "r")) == NULL) {
		sprintf (buf, "File %s not found.\n", fname);
        write (conns[target].sock, buf, strlen(buf));
        return;
    }
    while (!feof(fp)) {
        fgets (buf, 80, fp);
		if (!strncmp (buf, "END", 3))
			break;
        write (conns[target].sock, buf, strlen(buf));
    }
    fclose (fp);
}


/*
** We have received a complete line (denoted by a \n) from target.
** Now clear the packet buffer and reset the bytes read count.
*/ 
void clearbufs(int target)
{

    conns[target].bytes_read = 0;
	conns[target].pbufsize = BUFSIZE;
    conns[target].packetbuf = NULL;
}

void do_poss (int target, char *msg)
{
char outline[BUFSIZE];
	sprintf (outline, "%s%s\n", conns[target].name, msg);
	na (outline);
}

void kill_conn (int target, void *foo)
{
char buf[BUFSIZE];
int retval;

	write (conns[target].sock, "Bye.\n", 5);
#ifdef MAIN_ROOM
	sprintf (buf, "%s exits the room through a hatch in the wall.\n", 
			conns[target].name);
#else
	sprintf (buf, "%s has disconnected.\n", conns[target].name);
#endif
	nab (target, buf);
	retval = shutdown (conns[target].sock, 2);
	if (retval < 0) {
		sprintf (buf, "ERROR: shutdown: %d\n", errno);
		serverlog (buf);
	}
	close (conns[target].sock);
	delete_conn (target);
	return;
}

void conn_player (int target, char *rest)
{
register int i;
char *pwordptr;
char pbuf[20];
char pword[20], name[NAMESIZE];
char buffer[BUFSIZE];

	for (i=0; i < 20; i++) {
		pbuf[i] = '\0';
		pword[i] = '\0';
	}
	for (i=0; i < NAMESIZE; i++)
		name[i] = '\0';

		pwordptr = (char *) strchr (rest, ' ');
		if (!pwordptr) {
			serverlog ("NOTICE: Someone tried to connect with no space between their name and password.\n");
			spewfile (target, "fail.connect");
			return;
		}
		strcpy (pbuf, pwordptr);
		for (i=0; rest[i] != ' '; i++)
			name[i] = rest[i];
		name[i+1] = '\0';

		for (i=1; pbuf[i] != '\0'; i++)
			pword[i-1] = pbuf[i];
		pword [i] = '\0';

		if (strlen(name) <= 0) {
			write (conns[target].sock, "Name too short.\n", 16);
			return;
		}
		if (!validpass(name, pword)) {
			reject_conn (target);
			return;
		}
		strcpy (conns[target].name, name);
        conns[target].state = S_UNIDLE;
		strcpy (conns[target].doing, "Nothing.");
#ifdef MAIN_ROOM
		sprintf (buffer, "%s enters the room from a hatch in the wall.\n", 
				conns[target].name);
#else
		sprintf (buffer, "%s has connected.\n", conns[target].name);
#endif
        nab (target, buffer);

        sprintf(buffer, "CONNECT: %s from %s\n", conns[target].name,conns[target].address);
        serverlog (buffer);
        spewfile (target, "motd");
#ifdef MAIN_ROOM
		spewfile (target, "room.desc");
#endif
        sprintf (buffer, "You see: ");
        for (i = 0; i <= numconns-1; i++) {
        	if ((numconns == 1) || (i == numconns-1))
            	strcat (buffer, conns[i].name);
            else {
                strcat (buffer, conns[i].name);
                strcat (buffer, ", ");
            }
        }
        strcat (buffer, ".\n");
		write (conns[target].sock, buffer, strlen(buffer));
        return;

}



