/* This file should be included in all of the .c files */
/* (c) Jeff Blaine, 1993 */

#ifdef _HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <netinet/in.h>
#ifdef _HAVE_STRINGS_H
#include <strings.h>
#else
#include <string.h>
#endif

#define ARRAYSIZE 50          /* Maximum number of players allowed. */
#define BUFSIZE 1024          /* generic buffer size for socket IO  */
#define PBUF_START_SIZE 1024  /* packet buffer start size           */
#define NAMESIZE 15           /* Maximum name length                */

/* The player structure.  Each connection to the server has one of these */
struct connection {
	int sock;
	int state;
	char name[NAMESIZE];
	char doing[53];
	char address[41];
	struct sockaddr_in cli_addr;
	int bytes_read;
	int pbufsize;
	char *packetbuf;
};

/* Now we define the various player states (see above: int state;)    */
#define S_CONNECTING 0  /* player is connecting                       */
#define S_UNIDLE 1      /* player is set 'unidle'                     */
#define S_IDLE 2        /* player is set 'idle' from the idle command */
