#include <stdio.h>
#include <sys/types.h>
#include "player.h"

#if !defined(_LINUX) && !defined(__hpux)
extern char *crypt(char *key, char *salt);
#endif

int validname (char *name);
void create_player (int target, char *buf1);
int validpass (char *name, char *pword);
extern struct connection conns[ARRAYSIZE];
extern void serverlog (char *msg);
void reject_conn (int target);
extern void nab (int target, char *msg);
extern void spewfile (int target, char *fname);

void create_player (int target, char *buf1)
{
FILE *fp;
register int i;
char pbuf[20], pword[20], name[NAMESIZE];
char *pwordptr;
char emsg[BUFSIZE];

	for (i=0; i < 20; i++) {
		pbuf[i] = '\0';
		pword[i] = '\0';
	}
	for (i=0; i < NAMESIZE; i++)
		name[i] = '\0';
	pwordptr = (char *) strchr (buf1, ' ');
	if (!pwordptr) {
		spewfile (target, "fail.connect");
		return;
	}
	strcpy (pbuf, pwordptr);
	for (i=0; buf1[i] != ' '; i++)
		name[i] = buf1[i];
	name[i] = '\0';
	for (i=1; pbuf[i] != '\0'; i++)
		pword[i-1] = pbuf[i];
	pword[i] = '\0';
	if (strlen(name) >= NAMESIZE) {
		write (conns[target].sock, "Name too long.\n", 15);
		return;
	}
	if (strlen(name) <= 0) {
		write (conns[target].sock, "Name too short.\n", 16);
		return;
	}
	if (!validname(name)) {   /* Name not in use.  Proceed */
		if ((fp = fopen ("gcs.db", "a")) == NULL) {
			reject_conn (target);
			return;
		}
		fprintf (fp, "%s %s\n", name, crypt (pword, name));
		fclose (fp);
		strcpy (conns[target].name, name);
		conns[target].state = S_UNIDLE;
		strcpy (conns[target].doing, "Nothing.");
#ifdef MAIN_ROOM
		sprintf (buf1, "%s enters the room from a hatch in the wall.\n", 
				conns[target].name);
#else
		sprintf (buf1, "%s has created and connected.\n", conns[target].name);
#endif
		nab (target, buf1);
		sprintf(buf1, "CREATE: %s from %s\n", conns[target].name,conns[target].address);
		serverlog (buf1);
		spewfile (target, "motd");
#ifdef MAIN_ROOM
		spewfile (target, "room.desc");
#endif
		return;
	} else {
		sprintf(emsg,"Name already taken.  Choose another and create again.\n");
		write (conns[target].sock, emsg, strlen(emsg));
		return;
	}
}

int validname (char *name)
{
FILE *fp;
char player[NAMESIZE], pass[20];

	if ((fp = fopen ("gcs.db", "r")) == NULL)
		return(1);
	while (!feof(fp)) {
		fscanf (fp, "%s %s", player, pass);
		if (strlen(player) < 1) {
			fclose (fp);
			return(0);
		}
		if (!strcmp (name, player)) {
			fclose (fp);
			return (1);
		} else
			continue;
	}
	return (0);
}

int validpass (char *name, char *pword)
{
FILE *fp;
char player[NAMESIZE], pass[20];
char *crpw;

	if ((fp = fopen ("gcs.db", "r")) == NULL)
		return(0);
	while (!feof(fp)) {
		fscanf (fp, "%s %s", player, pass);
		if (strlen(player) < 1) {
			fclose (fp);
			return(0);
		}
		crpw = (char *) crypt (pword, name);
		if ((!strcmp (name, player)) && (!strcmp (crpw, pass))) {
			fclose (fp);
			return (1);
		} else
			continue;
	}
	return (0);
}

void reject_conn (int target)
{
char buf[80];

	sprintf (buf, "You have entered an invalid name or password.\n");
	write (conns[target].sock, buf, strlen(buf));
	sprintf (buf, "Use: create <user> <password> to create a user.\n");
	write (conns[target].sock, buf, strlen(buf));
	sprintf (buf, "If you have forgotten your password, send email to:\n");
	write (conns[target].sock, buf, strlen(buf));
	spewfile (target, "email");
}
